function [r,C,n] = fitcircle3D(y)
% [r,C,n] = fit_circle3D_v2(y)
 
% mean 
y_m = mean(y,1);

% subtract mean;
x = y - repmat(y_m,[size(y,1) 1]);
 
% check for points in a single plane
if any(all(~diff(x,1,1),1))
    p_p = double(all(~diff(x,1,1),1));
else
    % plane fit
    % not very efficient for large numbers of points but robust to rotation
    p_c = combnk(1:size(x,1),3);
    p_nn = zeros(size(p_c));
    for cnt_c = 1:size(p_c,1)
        p_nn(cnt_c,:) = cross(x(p_c(cnt_c,1),:) - x(p_c(cnt_c,2),:), ...
                              x(p_c(cnt_c,3),:) - x(p_c(cnt_c,2),:) );
    end
    p_NN = sum(p_nn.^2,2).^0.5;
    p_nn = p_nn./repmat(p_NN,[1 3]);
    p_nn(p_NN==0,:) = [];
    p_p = mean(p_nn,1);
end

% normalize
p_p = p_p/norm(p_p);

% find perpendicular vectors
p_Q = [null(p_p)'; p_p];

% project data
x_h = [x*p_Q(1,:)' x*p_Q(2,:)']';

% Find the best geometric fit
[c_h, r] = fitcircle(x_h);

% evaluate
C = ((p_Q^-1)*[c_h; 0])' + y_m;

% normal
n = p_Q(3,:);